# $Id: so_keepalive.tcl 71 2007-01-06 18:46:21Z kostix $
# "Socket keepalive" plugin for Tkabber.
# Written by Konstantin Khomoutov <flatworm@users.sourceforge.net>.
#
# NOTE that this is a HACK because of several things:
# * I can't currently say whether this does work at all;
# * If SIGPIPE is actually raised on disconnect due to expired keepalive
#   interval, what happens to the Tcl interpreter?
# * Not tested.
#
# Please test and provide your feedback.
# NOTE though, that socket keepalive settings are system dependent and
# not easily tweakable (see README).

# TODO does jlib have any specific proc for retreiving socket for connid?
# TODO change handling of SIGPIPE? In which way?

if [catch {package require Tclx}] {
	puts stderr {Tclx package is not available, so does socket keepalive feature}
	return
}

namespace eval sokeepalive {
	proc apply {connid} {
		set sock [set ::jlib::lib($connid,sck)]
		fcntl $sock KEEPALIVE 1
		if [infox have_posix_signals] {
			signal default SIGPIPE
		}

		debugmsg jlib "Socket keepalive status:\
			SO_KEEPALIVE: [fcntl $sock KEEPALIVE]\
			SIGPIPE: [if [infox have_posix_signals] \
				[signal get SIGPIPE] {return {not supported}}]"
	}

	::hook::add connected_hook [namespace current]::apply
}

